Index: NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/LBC/lbc_lnk_pt2pt_generic.h90
===================================================================
--- NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/LBC/lbc_lnk_pt2pt_generic.h90	(revision 14349)
+++ NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/LBC/lbc_lnk_pt2pt_generic.h90	(revision 14363)
@@ -1,4 +1,4 @@
 
-   SUBROUTINE lbc_lnk_pt2pt_/**/PRECISION( cdname, ptab, cd_nat, psgn, kfld, kfillmode, pfillval, lsend, lrecv )
+   SUBROUTINE lbc_lnk_pt2pt_/**/PRECISION( cdname, ptab, cd_nat, psgn, kfld, kfillmode, pfillval, khls, lsend, lrecv )
       CHARACTER(len=*)              , INTENT(in   ) ::   cdname      ! name of the calling subroutine
       TYPE(PTR_4d_/**/PRECISION),  DIMENSION(:), INTENT(inout) ::   ptab        ! pointer of arrays on which apply the b.c.
@@ -8,16 +8,17 @@
       INTEGER ,             OPTIONAL, INTENT(in   ) ::   kfillmode   ! filling method for halo over land (default = constant)
       REAL(PRECISION),      OPTIONAL, INTENT(in   ) ::   pfillval    ! background value (used at closed boundaries)
+      INTEGER ,             OPTIONAL, INTENT(in   ) ::   khls        ! halo size, default = nn_hls
       LOGICAL, DIMENSION(4),OPTIONAL, INTENT(in   ) ::   lsend, lrecv  ! communication with other 4 proc
       !
-      INTEGER  ::   ji, jj, jk, jl, jf, jn      ! dummy loop indices
-      INTEGER  ::   ipk, ipl, ipf      ! dimension of the input array
+      INTEGER  ::     ji,   jj,  jk,  jl,  jf, jn     ! dummy loop indices
+      INTEGER  ::    ipi,  ipj, ipk, ipl, ipf         ! dimension of the input array
       INTEGER  ::   ip0i, ip1i, im0i, im1i
       INTEGER  ::   ip0j, ip1j, im0j, im1j
       INTEGER  ::   ishti, ishtj, ishti2, ishtj2
       INTEGER  ::   ifill_nfd, icomm, ierr
-      INTEGER  ::   idxs, idxr
-      INTEGER, DIMENSION(4)  ::   isizei, ishtsi, ishtri, ishtpi
-      INTEGER, DIMENSION(4)  ::   isizej, ishtsj, ishtrj, ishtpj
-      INTEGER, DIMENSION(4)  ::   ifill, iszall, ishts, ishtr
+      INTEGER  ::   ihls, idxs, idxr
+      INTEGER, DIMENSION(4)  ::   isizei, ishtSi, ishtRi, ishtPi
+      INTEGER, DIMENSION(4)  ::   isizej, ishtSj, ishtRj, ishtPj
+      INTEGER, DIMENSION(4)  ::   ifill, iszall, ishtS, ishtR
       INTEGER, DIMENSION(4)  ::   ireq  ! mpi_request id
       REAL(PRECISION) ::   zland
@@ -31,4 +32,6 @@
       ! ----------------------------------------- !
       !
+      ipi = SIZE(ptab(1)%pt4d,1)
+      ipj = SIZE(ptab(1)%pt4d,2)
       ipk = SIZE(ptab(1)%pt4d,3)
       ipl = SIZE(ptab(1)%pt4d,4)
@@ -38,4 +41,19 @@
       !
       ! take care of optional parameters
+      !
+      ihls = nn_hls   ! default definition
+      IF( PRESENT( khls ) )   ihls = khls
+      IF( ihls > n_hlsmax ) THEN
+         WRITE(ctmp1,*) TRIM(cdname), ' is calling lbc_lnk with khls > n_hlsmax : ', khls, '>', n_hlsmax
+         CALL ctl_stop( 'STOP', ctmp1 )
+      ENDIF
+      IF( ipi /= Ni_0+2*ihls ) THEN
+         WRITE(ctmp1,*) TRIM(cdname), ' is calling lbc_lnk with an input array which does not match ihls along i: ', ipi, ihls, Ni_0
+         CALL ctl_stop( 'STOP', ctmp1 )
+      ENDIF
+      IF( ipj /= Nj_0+2*ihls ) THEN
+         WRITE(ctmp1,*) TRIM(cdname), ' is calling lbc_lnk with an input array which does not match ihls along j:', ipj, ihls , Nj_0
+         CALL ctl_stop( 'STOP', ctmp1 )
+      ENDIF
       !
       zland = 0._wp                                     ! land filling value: zero by default
@@ -46,9 +64,9 @@
          llsend(1:4) = lsend(1:4)   ;   llrecv(1:4) = lrecv(1:4)
       ELSE IF( PRESENT(lsend) .OR.  PRESENT(lrecv) ) THEN
-         WRITE(ctmp1,*) ' Routine ', cdname, '  is calling lbc_lnk with only one of the two arguments lsend or lrecv'
+         WRITE(ctmp1,*) TRIM(cdname), ' is calling lbc_lnk with only one of the two arguments lsend or lrecv'
          CALL ctl_stop( 'STOP', ctmp1 )
       ELSE                                                  ! default neighbours
-         llsend(1:4) = mpinei(1:4) >= 0
-         llrecv(:) = llsend(:)
+         llsend(:) = mpiSnei(ihls,1:4) >= 0
+         llrecv(:) = mpiRnei(ihls,1:4) >= 0
       END IF
       !
@@ -72,24 +90,26 @@
       ! or used for periodocity (p). The localization is defined as "the bottom left corner - 1" in i and j directions.
       ! This is a shift that will be applied later in the do loops to pick-up the appropriate part of the array
-      !                    !                       ________________________
-      ip0i =          0    !          im0j = inner |__|__|__________|__|__|
-      ip1i =      nn_hls   !   im1j = inner - halo |__|__|__________|__|__|
-      im1i = Nie0-nn_hls   !                       |  |  |          |  |  |
-      im0i = Nie0          !                       |  |  |          |  |  |
-      ip0j =          0    !                       |  |  |          |  |  |
-      ip1j =      nn_hls   !                       |__|__|__________|__|__|
-      im1j = Nje0-nn_hls   !           ip1j = halo |__|__|__________|__|__|
-      im0j = Nje0          !              ip0j = 0 |__|__|__________|__|__|
-      !                    !                    ip0i ip1i        im1i im0i
-      !
-      !     sides:       west    east   south   north
-      isizei(1:4) = (/ nn_hls, nn_hls,    jpi,    jpi /)   ! i- count
-      isizej(1:4) = (/    jpj,    jpj, nn_hls, nn_hls /)   ! j- count
-      ishtsi(1:4) = (/   ip1i,   im1i,   ip0i,   ip0i /)   ! i- shift send data
-      ishtsj(1:4) = (/   ip0j,   ip0j,   ip1j,   im1j /)   ! j- shift send data
-      ishtri(1:4) = (/   ip0i,   im0i,   ip0i,   ip0i /)   ! i- shift received data location
-      ishtrj(1:4) = (/   ip0j,   ip0j,   ip0j,   im0j /)   ! j- shift received data location
-      ishtpi(1:4) = (/   im1i,   ip1i,   ip0i,   ip0i /)   ! i- shift data used for periodicity
-      ishtpj(1:4) = (/   ip0j,   ip0j,   im1j,   ip1j /)   ! j- shift data used for periodicity
+      !
+      ! all definitions bellow do not refer to N[ij][se]0 so we can use it with any local value of ihls
+      !                   !                       ________________________
+      ip0i =          0   !          im0j = inner |__|__|__________|__|__|
+      ip1i =       ihls   !   im1j = inner - halo |__|__|__________|__|__|
+      im1i = ipi-2*ihls   !                       |  |  |          |  |  |
+      im0i = ipi - ihls   !                       |  |  |          |  |  |
+      ip0j =          0   !                       |  |  |          |  |  |
+      ip1j =       ihls   !                       |__|__|__________|__|__|
+      im1j = ipj-2*ihls   !           ip1j = halo |__|__|__________|__|__|
+      im0j = ipj - ihls   !              ip0j = 0 |__|__|__________|__|__|
+      !                   !                    ip0i ip1i        im1i im0i
+      !
+      !     sides:     west  east south north
+      isizei(1:4) = (/ ihls, ihls,  ipi,  ipi /)   ! i- count
+      isizej(1:4) = (/  ipj,  ipj, ihls, ihls /)   ! j- count
+      ishtSi(1:4) = (/ ip1i, im1i, ip0i, ip0i /)   ! i- shift send data
+      ishtSj(1:4) = (/ ip0j, ip0j, ip1j, im1j /)   ! j- shift send data
+      ishtRi(1:4) = (/ ip0i, im0i, ip0i, ip0i /)   ! i- shift received data location
+      ishtRj(1:4) = (/ ip0j, ip0j, ip0j, im0j /)   ! j- shift received data location
+      ishtPi(1:4) = (/ im1i, ip1i, ip0i, ip0i /)   ! i- shift data used for periodicity
+      ishtPj(1:4) = (/ ip0j, ip0j, im1j, ip1j /)   ! j- shift data used for periodicity
       !
       ! -------------------------------- !
@@ -99,11 +119,11 @@
       ireq(:) = MPI_REQUEST_NULL
       iszall(:) = isizei(:) * isizej(:) * ipk * ipl * ipf
-      ishts(1) = 0
+      ishtS(1) = 0
       DO jn = 2,4
-         ishts(jn) = ishts(jn-1) + iszall(jn-1) * COUNT( (/llsend(jn-1)/) )   ! with _alltoallv: in units of sendtype
-      END DO
-      ishtr(1) = 0
+         ishtS(jn) = ishtS(jn-1) + iszall(jn-1) * COUNT( (/llsend(jn-1)/) )   ! with _alltoallv: in units of sendtype
+      END DO
+      ishtR(1) = 0
       DO jn = 2,4
-         ishtr(jn) = ishtr(jn-1) + iszall(jn-1) * COUNT( (/llrecv(jn-1)/) )   ! with _alltoallv: in units of sendtype
+         ishtR(jn) = ishtR(jn-1) + iszall(jn-1) * COUNT( (/llrecv(jn-1)/) )   ! with _alltoallv: in units of sendtype
       END DO
 
@@ -119,6 +139,6 @@
       DO jn = 1, 2
          IF( llsend(jn) ) THEN
-            ishti = ishtsi(jn)
-            ishtj = ishtsj(jn)
+            ishti = ishtSi(jn)
+            ishtj = ishtSj(jn)
             DO jf = 1, ipf  ;  DO jl = 1, ipl  ;  DO jk = 1, ipk  ;  DO jj = 1,isizej(jn)  ;  DO ji = 1,isizei(jn)
                zsnd(idxs) = ptab(jf)%pt4d(ishti+ji,ishtj+jj,jk,jl)
@@ -134,12 +154,12 @@
       ! non-blocking send of the western/eastern side using local temporary arrays
       jn = jpwe
-      IF( llsend(jn) )   CALL MPI_ISEND( zsnd(ishts(jn)+1), iszall(jn), MPI_TYPE, mpinei(jn), 1, icomm, ireq(jn), ierr )
+      IF( llsend(jn) )   CALL MPI_ISEND( zsnd(ishtS(jn)+1), iszall(jn), MPI_TYPE, mpiSnei(ihls,jn), 1, icomm, ireq(jn), ierr )
       jn = jpea
-      IF( llsend(jn) )   CALL MPI_ISEND( zsnd(ishts(jn)+1), iszall(jn), MPI_TYPE, mpinei(jn), 2, icomm, ireq(jn), ierr )
+      IF( llsend(jn) )   CALL MPI_ISEND( zsnd(ishtS(jn)+1), iszall(jn), MPI_TYPE, mpiSnei(ihls,jn), 2, icomm, ireq(jn), ierr )
       ! blocking receive of the western/eastern halo in local temporary arrays
       jn = jpwe
-      IF( llrecv(jn) )   CALL MPI_RECV(  zrcv(ishtr(jn)+1), iszall(jn), MPI_TYPE, mpinei(jn), 2, icomm, MPI_STATUS_IGNORE, ierr )
+      IF( llrecv(jn) )   CALL MPI_RECV(  zrcv(ishtR(jn)+1), iszall(jn), MPI_TYPE, mpiRnei(ihls,jn), 2, icomm, MPI_STATUS_IGNORE, ierr )
       jn = jpea
-      IF( llrecv(jn) )   CALL MPI_RECV(  zrcv(ishtr(jn)+1), iszall(jn), MPI_TYPE, mpinei(jn), 1, icomm, MPI_STATUS_IGNORE, ierr )
+      IF( llrecv(jn) )   CALL MPI_RECV(  zrcv(ishtR(jn)+1), iszall(jn), MPI_TYPE, mpiRnei(ihls,jn), 1, icomm, MPI_STATUS_IGNORE, ierr )
       !
       IF( ln_timing ) CALL tic_tac(.FALSE.)
@@ -152,6 +172,6 @@
       idxr = 1
       DO jn = 1, 2
-         ishti = ishtri(jn)
-         ishtj = ishtrj(jn)
+         ishti = ishtRi(jn)
+         ishtj = ishtRj(jn)
          SELECT CASE ( ifill(jn) )
          CASE ( jpfillnothing )               ! no filling 
@@ -162,12 +182,12 @@
             END DO   ;   END DO   ;   END DO   ;   END DO   ;   END DO
          CASE ( jpfillperio )                 ! use periodicity
-            ishti2 = ishtpi(jn)
-            ishtj2 = ishtpj(jn)
+            ishti2 = ishtPi(jn)
+            ishtj2 = ishtPj(jn)
             DO jf = 1, ipf  ;  DO jl = 1, ipl  ;  DO jk = 1, ipk  ;  DO jj = 1,isizej(jn)  ;  DO ji = 1,isizei(jn)
                ptab(jf)%pt4d(ishti+ji,ishtj+jj,jk,jl) = ptab(jf)%pt4d(ishti2+ji,ishtj2+jj,jk,jl)
             END DO   ;   END DO   ;   END DO   ;   END DO   ;   END DO
          CASE ( jpfillcopy  )                 ! filling with inner domain values
-            ishti2 = ishtsi(jn)
-            ishtj2 = ishtsj(jn)
+            ishti2 = ishtSi(jn)
+            ishtj2 = ishtSj(jn)
             DO jf = 1, ipf  ;  DO jl = 1, ipl  ;  DO jk = 1, ipk  ;  DO jj = 1,isizej(jn)  ;  DO ji = 1,isizei(jn)
                ptab(jf)%pt4d(ishti+ji,ishtj+jj,jk,jl) = ptab(jf)%pt4d(ishti2+ji,ishtj2+jj,jk,jl)
@@ -187,6 +207,6 @@
       !
       IF( ll_IdoNFold ) THEN
-         IF( jpni == 1 )  THEN   ;   CALL lbc_nfd( ptab, cd_nat, psgn                  , ipf )   ! self NFold
-         ELSE                    ;   CALL mpp_nfd( ptab, cd_nat, psgn, ifill_nfd, zland, ipf )   ! mpi  NFold
+         IF( jpni == 1 )  THEN   ;   CALL lbc_nfd( ptab, cd_nat, psgn                  , ihls, ipf )   ! self NFold
+         ELSE                    ;   CALL mpp_nfd( ptab, cd_nat, psgn, ifill_nfd, zland, ihls, ipf )   ! mpi  NFold
          ENDIF
       ENDIF
@@ -198,6 +218,6 @@
       DO jn = 3, 4
          IF( llsend(jn) ) THEN
-            ishti = ishtsi(jn)
-            ishtj = ishtsj(jn)
+            ishti = ishtSi(jn)
+            ishtj = ishtSj(jn)
             DO jf = 1, ipf  ;  DO jl = 1, ipl  ;  DO jk = 1, ipk  ;  DO jj = 1,isizej(jn)  ;  DO ji = 1,isizei(jn)
                zsnd(idxs) = ptab(jf)%pt4d(ishti+ji,ishtj+jj,jk,jl)
@@ -212,12 +232,12 @@
       ! non-blocking send of the western/eastern side using local temporary arrays
       jn = jpso
-      IF( llsend(jn) )   CALL MPI_ISEND( zsnd(ishts(jn)+1), iszall(jn), MPI_TYPE, mpinei(jn), 3, icomm, ireq(jn), ierr )
+      IF( llsend(jn) )   CALL MPI_ISEND( zsnd(ishtS(jn)+1), iszall(jn), MPI_TYPE, mpiSnei(ihls,jn), 3, icomm, ireq(jn), ierr )
       jn = jpno
-      IF( llsend(jn) )   CALL MPI_ISEND( zsnd(ishts(jn)+1), iszall(jn), MPI_TYPE, mpinei(jn), 4, icomm, ireq(jn), ierr )
+      IF( llsend(jn) )   CALL MPI_ISEND( zsnd(ishtS(jn)+1), iszall(jn), MPI_TYPE, mpiSnei(ihls,jn), 4, icomm, ireq(jn), ierr )
       ! blocking receive of the western/eastern halo in local temporary arrays
       jn = jpso
-      IF( llrecv(jn) )   CALL MPI_RECV(  zrcv(ishtr(jn)+1), iszall(jn), MPI_TYPE, mpinei(jn), 4, icomm, MPI_STATUS_IGNORE, ierr )
+      IF( llrecv(jn) )   CALL MPI_RECV(  zrcv(ishtR(jn)+1), iszall(jn), MPI_TYPE, mpiRnei(ihls,jn), 4, icomm, MPI_STATUS_IGNORE, ierr )
       jn = jpno
-      IF( llrecv(jn) )   CALL MPI_RECV(  zrcv(ishtr(jn)+1), iszall(jn), MPI_TYPE, mpinei(jn), 3, icomm, MPI_STATUS_IGNORE, ierr )
+      IF( llrecv(jn) )   CALL MPI_RECV(  zrcv(ishtR(jn)+1), iszall(jn), MPI_TYPE, mpiRnei(ihls,jn), 3, icomm, MPI_STATUS_IGNORE, ierr )
       !
       IF( ln_timing ) CALL tic_tac(.FALSE.)
@@ -229,6 +249,6 @@
       !
       DO jn = 3, 4
-         ishti = ishtri(jn)
-         ishtj = ishtrj(jn)
+         ishti = ishtRi(jn)
+         ishtj = ishtRj(jn)
          SELECT CASE ( ifill(jn) )
          CASE ( jpfillnothing )               ! no filling 
@@ -239,12 +259,12 @@
             END DO   ;   END DO   ;   END DO   ;   END DO   ;   END DO
          CASE ( jpfillperio )                 ! use periodicity
-            ishti2 = ishtpi(jn)
-            ishtj2 = ishtpj(jn)
+            ishti2 = ishtPi(jn)
+            ishtj2 = ishtPj(jn)
             DO jf = 1, ipf  ;  DO jl = 1, ipl  ;  DO jk = 1, ipk  ;  DO jj = 1,isizej(jn)  ;  DO ji = 1,isizei(jn)
                ptab(jf)%pt4d(ishti+ji,ishtj+jj,jk,jl) = ptab(jf)%pt4d(ishti2+ji,ishtj2+jj,jk,jl)
             END DO   ;   END DO   ;   END DO   ;   END DO   ;   END DO
          CASE ( jpfillcopy  )                 ! filling with inner domain values
-            ishti2 = ishtsi(jn)
-            ishtj2 = ishtsj(jn)
+            ishti2 = ishtSi(jn)
+            ishtj2 = ishtSj(jn)
             DO jf = 1, ipf  ;  DO jl = 1, ipl  ;  DO jk = 1, ipk  ;  DO jj = 1,isizej(jn)  ;  DO ji = 1,isizei(jn)
                ptab(jf)%pt4d(ishti+ji,ishtj+jj,jk,jl) = ptab(jf)%pt4d(ishti2+ji,ishtj2+jj,jk,jl)
